//-----------------------------------------------------------------------------
// Title      : bsp_ub009_mk3_rs232
//-----------------------------------------------------------------------------
// Funktion   : RS232 Test
// Schaltung  : myAVR MK3
//-----------------------------------------------------------------------------
// Prozessor  : ATMega2560
// Takt       : 16 MHz
// Sprache    : C
// Date       : 13.02.2010
// Version    : 1.0
// Autor      : UB
//-----------------------------------------------------------------------------
#define F_CPU 16000000
#include <avr/io.h>
#include <ub_mk3_2560/MK3_2560_LCD.h>
#include <ub_mk3_2560/MK3_2560_KEY.h>
#include <ub_mk3_2560/MK3_2560_V24.h>

char buf[RX_PUFFER_LEN];

//-----------------------------------------------------------------------------
// Hinweis : Quick-Jumper Port-C+A, Port-K muss gesetzt sein
// - sendet bei Tastendruck einen String
// - zeigt einen empfangenen String an
//-----------------------------------------------------------------------------
int main (void)
{
	MK3_INIT_LCD();					// init des LCD
	MK3_INIT_KEY();					// init der Tasten
	MK3_INIT_V24(COM1,B38400);		// init der V24 am mySmartUSB MK3
	
	MK3_LCD_CLEAR();				// LCD loeschen
	MK3_LCD_LIGHT(true);			// beleuchtung einschalten
	
	MK3_LCD_STRING_AT(0,0,"RS232 Terminal");
	MK3_LCD_STRING_AT(0,8,"COM1, 38400Baud, 8N1");
	
	MK3_LCD_STRING_AT(0,16,"Taste1 sendet 'Hallo'");
	MK3_LCD_STRING_AT(0,40,"Rx=                ");

	while (true)
	{
		// sende bei Tastendruck einen Text
		if(MK3_KEY_SET(BUTTON1)) {
		  MK3_LCD_STRING_AT(0,32,"sende...");
		  MK3_V24_OUT(COM1,"Hallo",RX_END_CRLF);
		  MK3_LCD_STRING_AT(0,40,"Rx=                ");
		}
		else {
		  if(MK3_KEY_PRESS(BUTTON1)==false) {
		    MK3_LCD_STRING_AT(0,32,"           ");
		  }
		}
		
		// warte auf Daten
		if(MK3_V24_IN(COM1,buf)) {
		  MK3_LCD_STRING_AT(0,40,"Rx=");
		  MK3_LCD_PRINT_STRING(buf);		  
		}
	}
	return 0;
}
//-----------------------------------------------------------------------------






